% Copyright (C) 2008-2010 - Consortium Scilab - Digiteo - Michael Baudin
%
% This file must be used under the terms of the 
% Creative Commons Attribution-ShareAlike 3.0 Unported License :
% http://creativecommons.org/licenses/by-sa/3.0/

\chapter{Conclusion}

In this document, we have presented the Nelder-Mead component 
of Scilab. The Nelder-Mead simplex algorithm is a direct search 
algorithm for multidimensional unconstrained optimization. It does not 
require the derivative of the objective function and is based on the 
update of a simplex made of $n+1$ points, where $n$ is the dimension
of the problem.

We have presented the theory associated to simplex 
based algorithms. We have presented several initial simplex and 
emphasize their importance with respect to the convergence 
of the algorithm. We have presented the simplex gradient 
and presented a result due to Kelley which shows that, under regularity 
hypothesis, the simplex gradient is a good approximation of the 
gradient of the objective function. We have shown an example 
where a degenerate simplex produces a poor approximation of the 
simplex gradient. 

We have presented Spendley's et al algorithm based on a fixed 
shape simplex. We have presented several numerical experiments with 
this algorithm and shown that this algorithm requires many 
function evaluations in the case of a badly scaled quadratic function.

The algorithm designed by Nelder and Mead has been analyzed.
We presented several methods to restart the algorithm and detection
methods to see if it has failed. We have presented the O'Neill factorial test 
and Kelley's stagnation detection based on the simplex gradient. 
We have analyzed the convergence properties of this algorithm
on a quadratic function, as introduced by Han and Neumman. 
Several numerical experiments have been presented. We have shown that 
the Nelder-Mead algorithm does not require as many function evaluations 
as Spendley's et al algorithm, even in the case of a badly scaled 
quadratic function. 
We were able to see that the Nelder-Mead algorithm can become slower 
and slower as the dimension increases, as suggested by Han and Neumman. 
We have shown several numerical experiments 
where the Nelder-Mead algorithm converges to a non-stationnary 
point. These counter examples include the examples by Mc Kinnon and 
Han and Neumman. We have reproduced with Scilab the stagnation 
detection and automatic restart on Mc Kinnon examples, as suggested 
by Kelley. We reproduced Torczon's numerical experiments
which show that, in some cases, the search direction of the Nelder-Mead
algorithm becomes orthogonal to the gradient of the objective function.

In the final section of this document, we have presented the \emph{fminsearch}
function included in Scilab and which is based on the Nelder-Mead component.
We have analyzed the particular set of algorithmic parameters which 
is specific to this implementation of the algorithm. We have shown several 
numerical experiments which show that the new implementation correctly 
reproduces Matlab's \emph{fminsearch} function.

This module has been integrated to Scilab v5.2 in 2009. In \cite{5416860},
we used this component to find a matrix which maximizes the error 
committed by the 1-norm condition estimator \emph{rcond} in Scilab. 
This problem was first introduced by Nicolas Higham in \cite{Higham:2002:ASN},
as an example of a good test case for a direct search method since the 
condition estimator is a non-smooth objective function. In this context, 
the direct search algorithm is able to find automatically a matrix 
for which the 1-norm condition estimator is overestimating the condition
number by a 1.5 factor. This test case makes gradient-based algorithm
fail, not only because the objective function has no derivatives 
for some points in the domain, but also because the gradient is exactly
zero on large areas of the surface. Moreover, the optimum 
is located near a singularity of the objective function. 
In this case, genetic algorithms require much more function evaluations. 


